package gregapi;

import static gregapi.data.CS.*;
import gregapi.block.prefixblock.PrefixBlockFallingEntity;
import gregapi.block.prefixblock.PrefixBlockTileEntity;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.FluidStackContainer;
import gregapi.code.HashSetNoNulls;
import gregapi.code.ItemStackContainer;
import gregapi.compat.CompatBase;
import gregapi.compat.buildcraft.ICompatBC;
import gregapi.compat.thaumcraft.ICompatTC;
import gregapi.config.Config;
import gregapi.data.*;
import gregapi.data.CS.ModIDs;
import gregapi.enchants.Enchantment_EnderDamage;
import gregapi.enchants.Enchantment_Radioactivity;
import gregapi.item.ItemFluidDisplay;
import gregapi.item.ItemIntegratedCircuit;
import gregapi.lang.LanguageHandler;
import gregapi.load.LoaderItemData;
import gregapi.load.LoaderItemList;
import gregapi.load.LoaderOreDictReRegistrations;
import gregapi.log.GT_Log;
import gregapi.log.GT_Log.LogBuffer;
import gregapi.log.LoggerPlayerActivity;
import gregapi.network.NetworkHandler;
import gregapi.network.packets.PacketConfig;
import gregapi.network.packets.PacketSound;
import gregapi.network.packets.covers.*;
import gregapi.network.packets.covervisuals.*;
import gregapi.network.packets.data.*;
import gregapi.network.packets.ids.*;
import gregapi.oredict.OreDictManager;
import gregapi.recipes.AdvancedCraftingShaped;
import gregapi.recipes.AdvancedCraftingShapeless;
import gregapi.recipes.GT_ModHandler;
import gregapi.recipes.Recipe;
import gregapi.util.OM;
import gregapi.util.UT;

import java.io.File;
import java.io.PrintStream;
import java.util.*;

import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.CraftingManager;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraftforge.common.ChestGenHooks;
import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.oredict.RecipeSorter;
import net.minecraftforge.oredict.ShapedOreRecipe;
import net.minecraftforge.oredict.ShapelessOreRecipe;
import cpw.mods.fml.common.*;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.*;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.EntityRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 */
@Mod(modid = ModIDs.API, name="Greg-API", version="GT6-MC1710", dependencies="before:"+ModIDs.GT+"; before:"+ModIDs.IC2+"; before:"+ModIDs.NC+"; before:"+ModIDs.FR+"; before:"+ModIDs.UB+"; before:"+ModIDs.PFAA+"; before:"+ModIDs.TC+"; before:"+ModIDs.RC+"; before:"+ModIDs.AE+"; before:"+ModIDs.TE+"; before:"+ModIDs.CHSL+"; before:"+ModIDs.TF+"; before:"+ModIDs.HaC+"; before:"+ModIDs.MaCr+"; before:"+ModIDs.BC_TRANSPORT+"; before:"+ModIDs.BC_SILICON+"; before:"+ModIDs.BC_FACTORY+"; before:"+ModIDs.BC_ENERGY+"; before:"+ModIDs.BC_CORE+"; before:"+ModIDs.BC_BUILDERS+"; before:"+ModIDs.GC_CORE+"; before:"+ModIDs.GC_MARS+"; before:"+ModIDs.GC_PLANETS+"; before:"+ModIDs.ATUM+"; before:ThermalExpansion|Transport; before:ThermalExpansion|Energy; before:ThermalExpansion|Factory; before:RedPowerCore; before:RedPowerBase; before:RedPowerMachine; before:RedPowerCompat; before:RedPowerWiring; before:RedPowerLogic; before:RedPowerLighting; before:RedPowerWorld; before:RedPowerControl;" /*before:ProjRed; before:ProjRed|Exploration; before:UndergroundBiomes; before:NetherOres; before:factorization; before:XyCraft; before:MetallurgyCore; before:MetallurgyBase; before:MetallurgyEnder; before:MetallurgyFantasy; before:MetallurgyNether; before:MetallurgyPrecious; before:MetallurgyUtility; before:BuildCraft|Silicon; before:BuildCraft|Core; before:BuildCraft|Transport; before:BuildCraft|Factory; before:BuildCraft|Energy; before:BuildCraft|Builders; before:TConstruct; before:TConstruct-Preloader; before:TMechworks; before:TwilightForest; before:Tubestuff; before:ICBM; before:Mekanism; before:MekanismGenerators; before:MekanismTools; before:ThaumicTinkerer; before:LiquidXP; before:MineFactoryReloaded; before:factorization.misc; before:AtomicScience; before:MFFS; before:ICBM|Contraption; before:ICBM|Explosion; before:ICBM|Sentry; before:mmmPowersuits;"*/)
public class GT_API {
    @Instance(value = ModIDs.API)
    public static GT_API instance;
    @SidedProxy(modId = ModIDs.API, clientSide = "gregapi.GT_API_Proxy_Client", serverSide = "gregapi.GT_API_Proxy_Server")
    public static GT_API_Proxy api_proxy;
	public static final int VERSION = 600;
	
	public static final Collection<Map<ItemStackContainer, ?>>	STACKMAPS = new ArrayListNoNulls<Map<ItemStackContainer, ?>>();
	public static final Collection<Map<Fluid, ?>>				FLUIDMAPS = new ArrayListNoNulls<Map<Fluid, ?>>();
	
	public static boolean
	sGregTechLoaded						= false,
	
	sAPIPhaseStartedPreLoad				= false, sAPIPhaseFinishedPreLoad			= false,
	sAPIPhaseStartedLoad				= false, sAPIPhaseFinishedLoad				= false,
	sAPIPhaseStartedPostLoad			= false, sAPIPhaseFinishedPostLoad			= false,
	
	sAPIPhaseStartedServerStarting		= false, sAPIPhaseFinishedServerStarting	= false,
	sAPIPhaseStartedServerStarted		= false, sAPIPhaseFinishedServerStarted		= false,
	sAPIPhaseStartedServerStopping		= false, sAPIPhaseFinishedServerStopping	= false,
	sAPIPhaseStartedServerStopped		= false, sAPIPhaseFinishedServerStopped		= false,
	
	sGTPhaseStartedPreLoad				= false, sGTPhaseFinishedPreLoad			= false,
	sGTPhaseStartedLoad					= false, sGTPhaseFinishedLoad				= false,
	sGTPhaseStartedPostLoad				= false, sGTPhaseFinishedPostLoad			= false,
	
	sEnableDynamicWritingToConfig		= false;
	
	/**
	 * A lot of Event Lists where you can hook into the loading order of the Code.
	 * 
	 * Note, that some of the Lists (the ones of the Load Phases) will be cleared and then set to null, right after they got executed once, in order to clean up some RAM.
	 * 
	 * Note to myself: DO NOT TRY TO MAKE THOSE TO HASHSETS AGAIN!
	 */
	public static List<Runnable> 
	sAPIPreInitBefore					= new ArrayListNoNulls<Runnable>(), sAPIPreInitAfter				= new ArrayListNoNulls<Runnable>(),
	sAPIInitBefore						= new ArrayListNoNulls<Runnable>(), sAPIInitAfter					= new ArrayListNoNulls<Runnable>(),
	sAPIPostInitBefore					= new ArrayListNoNulls<Runnable>(), sAPIPostInitAfter				= new ArrayListNoNulls<Runnable>(),
	
	sAPIServerStartingBefore			= new ArrayListNoNulls<Runnable>(), sAPIServerStartingAfter			= new ArrayListNoNulls<Runnable>(),
	sAPIServerStartedBefore				= new ArrayListNoNulls<Runnable>(), sAPIServerStartedAfter			= new ArrayListNoNulls<Runnable>(),
	sAPIServerStoppingBefore			= new ArrayListNoNulls<Runnable>(), sAPIServerStoppingAfter			= new ArrayListNoNulls<Runnable>(),
	sAPIServerStoppedBefore				= new ArrayListNoNulls<Runnable>(), sAPIServerStoppedAfter			= new ArrayListNoNulls<Runnable>(),
	
	sGTPreInitBefore					= new ArrayListNoNulls<Runnable>(), sGTPreInitAfter					= new ArrayListNoNulls<Runnable>(),
	sGTInitBefore						= new ArrayListNoNulls<Runnable>(), sGTInitAfter					= new ArrayListNoNulls<Runnable>(),
	sGTPostInitBefore					= new ArrayListNoNulls<Runnable>(), sGTPostInitAfter				= new ArrayListNoNulls<Runnable>(),
	
	sGTServerStartingBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStartingAfter			= new ArrayListNoNulls<Runnable>(),
	sGTServerStartedBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStartedAfter			= new ArrayListNoNulls<Runnable>(),
	sGTServerStoppingBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStoppingAfter			= new ArrayListNoNulls<Runnable>(),
	sGTServerStoppedBefore				= new ArrayListNoNulls<Runnable>(), sGTServerStoppedAfter			= new ArrayListNoNulls<Runnable>();
	
	/** Used to register Icons. It is not necessary to make those into Lists */
	public static Set<Runnable> sBlockIconload = new HashSetNoNulls<Runnable>(), sItemIconload = new HashSetNoNulls<Runnable>();
	/** The Icon Registers from Blocks and Items. They will get set right before the corresponding Icon Load Phase as executed in the Runnable List above. */
	@SideOnly(Side.CLIENT)
	public static IIconRegister sBlockIcons, sItemIcons;
	
	/** Used to register Aspects to ThaumCraft, this Object might be null if ThaumCraft isn't installed. */
	public static ICompatTC sCompatTC;
	/** Used to register BuildCraft Stuff, this Object might be null if BuildCraft isn't installed. */
	public static ICompatBC sCompatBC;
	
	private LoggerPlayerActivity mPlayerLogger;
	
	public GT_API() {
		// A bunch of Code that is there to statically initialise the Database in the right order.
		BI.BAROMETER.toString();
		MT.NULL.toString();
		AM.Hydrogen.toString();
		OP.ore.toString();
		
		// It is VERY important that those are registered first. Otherwise GregTech would output its own Storage Blocks.
        OreDictManager.INSTANCE.setTarget(OP.blockIngot			, MT.Iron				, new ItemStack(Blocks.iron_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockIngot			, MT.Gold				, new ItemStack(Blocks.gold_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Diamond			, new ItemStack(Blocks.diamond_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Emerald			, new ItemStack(Blocks.emerald_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Lapis				, new ItemStack(Blocks.lapis_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem			, MT.Coal				, new ItemStack(Blocks.coal_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockDust			, MT.Redstone			, new ItemStack(Blocks.redstone_block, 1, 0));
	}
    
	@EventHandler
    public void onPreLoad(FMLPreInitializationEvent aEvent) {
        GT_Log.out.println("GT_API: ======================");
        GT_Log.ore.println("GT_API: ======================");
        
    	for (Runnable tRunnable : sAPIPreInitBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPreInitBefore.clear();
    	sAPIPreInitBefore = null;
    	
        GT_Log.out.println("GT_API: PreLoad-Phase started!");
        GT_Log.ore.println("GT_API: PreLoad-Phase started!");
        
		sAPIPhaseStartedPreLoad = true;
		
    	Config.sConfigFileIDs = new Configuration(new File(new File(aEvent.getModConfigurationDirectory(), "GregTech"), "IDs.cfg")); Config.sConfigFileIDs.save();
    	Configuration tMainConfig = new Configuration(new File(new File(aEvent.getModConfigurationDirectory(), "GregTech"), "GregTech.cfg"));
    	
    	GT_Log.mLogFile = new File(aEvent.getModConfigurationDirectory().getParentFile(), "logs/GregTech.log");
    	if (!GT_Log.mLogFile.exists()) try {GT_Log.mLogFile.createNewFile();} catch(Throwable e) {/*Do nothing*/}
		
    	List<String>
		tList1 = ((LogBuffer)GT_Log.err).mBufferedLog, tList2 = ((LogBuffer)GT_Log.out).mBufferedLog;
    	try {
    		GT_Log.err = GT_Log.out = new PrintStream(GT_Log.mLogFile);
    	} catch (Throwable e) {
    		GT_Log.err = System.err;
    		GT_Log.out = System.out;
    	}
    	
		for (String tString : tList1) GT_Log.err.println(tString);
		for (String tString : tList2) GT_Log.out.println(tString);
		
    	GT_Log.mOreDictLogFile = new File(aEvent.getModConfigurationDirectory().getParentFile(), "logs/OreDict.log");
    	if (!GT_Log.mOreDictLogFile.exists()) {try {GT_Log.mOreDictLogFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    	
    	if (tMainConfig.get("general", "LoggingPlayerActivity", true).getBoolean(true)) {
    		File tFile = new File(aEvent.getModConfigurationDirectory().getParentFile(), "logs/PlayerActivity.log");
        	if (!tFile.exists()) {try {tFile.createNewFile();} catch (Throwable e) {/*Do nothing*/}}
    		try {mPlayerLogger = new LoggerPlayerActivity(new PrintStream(tFile));} catch (Throwable e) {/*Do nothing*/}
    	}
    	
		try {
			tList1 = ((LogBuffer)GT_Log.ore).mBufferedLog;
    		GT_Log.ore = new PrintStream(GT_Log.mOreDictLogFile);
    		GT_Log.ore.println("**********************************************************************");
    		GT_Log.ore.println("* This is the complete Log of the GregTech OreDictionary Handler     *");
    		GT_Log.ore.println("* Everything in the OreDict goes through it sometimes causing Errors *");
    		GT_Log.ore.println("* These Errors are getting logged aswell as properly registered Ores *");
    		GT_Log.ore.println("* If you see something fishy going on in this Log, such as improper  *");
    		GT_Log.ore.println("* Items being registered, then mention it to the corresponding Mod   *");
    		GT_Log.ore.println("* In case it mentions GregTech itself improperly registering Stuff   *");
    		GT_Log.ore.println("* then please contact me about that immediatly                       *");
    		GT_Log.ore.println("*                                                                    *");
    		GT_Log.ore.println("* In case of something being 'ignored properly', that one isnt a Bug *");
    		GT_Log.ore.println("**********************************************************************");
    		for (String tString : tList1) GT_Log.ore.println(tString);
		} catch (Throwable e) {/*Do nothing*/}
    	D1 = tMainConfig.get("general", "Debug1", F).getBoolean(F);
    	D2 = tMainConfig.get("general", "Debug2", F).getBoolean(F);
    	
    	if (D1) {
    		tList1 = ((LogBuffer)GT_Log.deb).mBufferedLog;
        	GT_Log.deb = GT_Log.out;
    		for (String tString : tList1) GT_Log.deb.println(tString);
    	}
    	
    	SHOW_HIDDEN_ITEMS				= tMainConfig.get("general", "ShowHiddenItems"				, F).getBoolean(F);
    	SHOW_HIDDEN_PREFIXES			= tMainConfig.get("general", "ShowHiddenPrefixes"			, F).getBoolean(F);
    	SHOW_HIDDEN_MATERIALS			= tMainConfig.get("general", "ShowHiddenMaterials"			, F).getBoolean(F);
    	SURVIVAL_INTO_ADVENTURE_MODE	= tMainConfig.get("general", "forceAdventureMode"			, F).getBoolean(F);
    	ADVENTURE_MODE_AXE				= tMainConfig.get("general", "AdventureModeStartingAxe"		, T).getBoolean(T);
    	HUNGER_BY_INVENTORY_WEIGT		= tMainConfig.get("general", "AFK_Hunger"					, F).getBoolean(F);
    	INVENTORY_UNIFICATION			= tMainConfig.get("general", "InventoryUnification"			, T).getBoolean(T);
    	HARDNESS_MULTIPLIER_SAND		= tMainConfig.get("general", "HardnessMultiplier_Sand"		, 1.0).getDouble(1.0);
    	HARDNESS_MULTIPLIER_ROCK		= tMainConfig.get("general", "HardnessMultiplier_Rock"		, 1.0).getDouble(1.0);
    	HARDNESS_MULTIPLIER_ORES		= tMainConfig.get("general", "HardnessMultiplier_Ores"		, 1.0).getDouble(1.0);
    	
    	if (HARDNESS_MULTIPLIER_SAND <= 0.0) HARDNESS_MULTIPLIER_SAND = 1.0;
    	if (HARDNESS_MULTIPLIER_ROCK <= 0.0) HARDNESS_MULTIPLIER_ROCK = 1.0;
    	if (HARDNESS_MULTIPLIER_ORES <= 0.0) HARDNESS_MULTIPLIER_ORES = 1.0;
    	
    	if (tMainConfig.get("compat", "ThaumCraft"	, T).getBoolean(T)) sCompatTC = (ICompatTC)UT.Reflection.callConstructor("gregapi.compat.thaumcraft.CompatTC", 0, null, D1);
    	if (tMainConfig.get("compat", "BuildCraft"	, T).getBoolean(T)) sCompatBC = (ICompatBC)UT.Reflection.callConstructor("gregapi.compat.buildcraft.CompatBC", 0, null, D1);
    	
    	tMainConfig.save();
    	
    	// Register Crafting Recipe Classes.
        RecipeSorter.register("gregtech:shaped"			, AdvancedCraftingShaped.class				, net.minecraftforge.oredict.RecipeSorter.Category.SHAPED		, "after:minecraft:shaped before:minecraft:shapeless");
        RecipeSorter.register("gregtech:shapeless"		, AdvancedCraftingShapeless.class			, net.minecraftforge.oredict.RecipeSorter.Category.SHAPELESS	, "after:minecraft:shapeless");
		// A Default Packet Handler for some of the already existing Code. Yes, all those Packets are generalised special cases in order to save on Bandwidth.
		// [        +127] = PacketConfig
        // [-120 to + 71] = PacketSyncData
		// [-128 to -121] = PacketSound
		NW_API = new NetworkHandler(ModIDs.API, "GAPI", new PacketConfig()
		, new PacketSyncDataByte						( 0), new PacketSyncDataByte						( 1), new PacketSyncDataByte						( 2), new PacketSyncDataByte						( 3), new PacketSyncDataByte						( 4), new PacketSyncDataByte						( 5), new PacketSyncDataByte						( 6), new PacketSyncDataByte						( 7)
		, new PacketSyncDataShort						( 0), new PacketSyncDataShort						( 1), new PacketSyncDataShort						( 2), new PacketSyncDataShort						( 3), new PacketSyncDataShort						( 4), new PacketSyncDataShort						( 5), new PacketSyncDataShort						( 6), new PacketSyncDataShort						( 7)
		, new PacketSyncDataInteger						( 0), new PacketSyncDataInteger						( 1), new PacketSyncDataInteger						( 2), new PacketSyncDataInteger						( 3), new PacketSyncDataInteger						( 4), new PacketSyncDataInteger						( 5), new PacketSyncDataInteger						( 6), new PacketSyncDataInteger						( 7)
		, new PacketSyncDataLong						( 0), new PacketSyncDataLong						( 1), new PacketSyncDataLong						( 2), new PacketSyncDataLong						( 3), new PacketSyncDataLong						( 4), new PacketSyncDataLong						( 5), new PacketSyncDataLong						( 6), new PacketSyncDataLong						( 7)
		, new PacketSyncDataByteArray					( 0), new PacketSyncDataByteArray					( 1), new PacketSyncDataByteArray					( 2), new PacketSyncDataByteArray					( 3), new PacketSyncDataByteArray					( 4), new PacketSyncDataByteArray					( 5), new PacketSyncDataByteArray					( 6), new PacketSyncDataByteArray					( 7)
		, new PacketSyncDataName						( 0), new PacketSyncDataName						( 1), new PacketSyncDataName						( 2), new PacketSyncDataName						( 3), new PacketSyncDataName						( 4), new PacketSyncDataName						( 5), new PacketSyncDataName						( 6), new PacketSyncDataName						( 7)
		, new PacketSyncDataIDs							( 0), new PacketSyncDataIDs							( 1), new PacketSyncDataIDs							( 2), new PacketSyncDataIDs							( 3), new PacketSyncDataIDs							( 4), new PacketSyncDataIDs							( 5), new PacketSyncDataIDs							( 6), new PacketSyncDataIDs							( 7)
		, new PacketSyncDataByteAndIDs					( 0), new PacketSyncDataByteAndIDs					( 1), new PacketSyncDataByteAndIDs					( 2), new PacketSyncDataByteAndIDs					( 3), new PacketSyncDataByteAndIDs					( 4), new PacketSyncDataByteAndIDs					( 5), new PacketSyncDataByteAndIDs					( 6), new PacketSyncDataByteAndIDs					( 7)
		, new PacketSyncDataShortAndIDs					( 0), new PacketSyncDataShortAndIDs					( 1), new PacketSyncDataShortAndIDs					( 2), new PacketSyncDataShortAndIDs					( 3), new PacketSyncDataShortAndIDs					( 4), new PacketSyncDataShortAndIDs					( 5), new PacketSyncDataShortAndIDs					( 6), new PacketSyncDataShortAndIDs					( 7)
		, new PacketSyncDataIntegerAndIDs				( 0), new PacketSyncDataIntegerAndIDs				( 1), new PacketSyncDataIntegerAndIDs				( 2), new PacketSyncDataIntegerAndIDs				( 3), new PacketSyncDataIntegerAndIDs				( 4), new PacketSyncDataIntegerAndIDs				( 5), new PacketSyncDataIntegerAndIDs				( 6), new PacketSyncDataIntegerAndIDs				( 7)
		, new PacketSyncDataLongAndIDs					( 0), new PacketSyncDataLongAndIDs					( 1), new PacketSyncDataLongAndIDs					( 2), new PacketSyncDataLongAndIDs					( 3), new PacketSyncDataLongAndIDs					( 4), new PacketSyncDataLongAndIDs					( 5), new PacketSyncDataLongAndIDs					( 6), new PacketSyncDataLongAndIDs					( 7)
		, new PacketSyncDataByteArrayAndIDs				( 0), new PacketSyncDataByteArrayAndIDs				( 1), new PacketSyncDataByteArrayAndIDs				( 2), new PacketSyncDataByteArrayAndIDs				( 3), new PacketSyncDataByteArrayAndIDs				( 4), new PacketSyncDataByteArrayAndIDs				( 5), new PacketSyncDataByteArrayAndIDs				( 6), new PacketSyncDataByteArrayAndIDs				( 7)
		, new PacketSyncDataIDsAndCovers				( 0), new PacketSyncDataIDsAndCovers				( 1), new PacketSyncDataIDsAndCovers				( 2), new PacketSyncDataIDsAndCovers				( 3), new PacketSyncDataIDsAndCovers				( 4), new PacketSyncDataIDsAndCovers				( 5), new PacketSyncDataIDsAndCovers				( 6), new PacketSyncDataIDsAndCovers				( 7)
		, new PacketSyncDataByteAndIDsAndCovers			( 0), new PacketSyncDataByteAndIDsAndCovers			( 1), new PacketSyncDataByteAndIDsAndCovers			( 2), new PacketSyncDataByteAndIDsAndCovers			( 3), new PacketSyncDataByteAndIDsAndCovers			( 4), new PacketSyncDataByteAndIDsAndCovers			( 5), new PacketSyncDataByteAndIDsAndCovers			( 6), new PacketSyncDataByteAndIDsAndCovers			( 7)
		, new PacketSyncDataShortAndIDsAndCovers		( 0), new PacketSyncDataShortAndIDsAndCovers		( 1), new PacketSyncDataShortAndIDsAndCovers		( 2), new PacketSyncDataShortAndIDsAndCovers		( 3), new PacketSyncDataShortAndIDsAndCovers		( 4), new PacketSyncDataShortAndIDsAndCovers		( 5), new PacketSyncDataShortAndIDsAndCovers		( 6), new PacketSyncDataShortAndIDsAndCovers		( 7)
		, new PacketSyncDataIntegerAndIDsAndCovers		( 0), new PacketSyncDataIntegerAndIDsAndCovers		( 1), new PacketSyncDataIntegerAndIDsAndCovers		( 2), new PacketSyncDataIntegerAndIDsAndCovers		( 3), new PacketSyncDataIntegerAndIDsAndCovers		( 4), new PacketSyncDataIntegerAndIDsAndCovers		( 5), new PacketSyncDataIntegerAndIDsAndCovers		( 6), new PacketSyncDataIntegerAndIDsAndCovers		( 7)
		, new PacketSyncDataLongAndIDsAndCovers			( 0), new PacketSyncDataLongAndIDsAndCovers			( 1), new PacketSyncDataLongAndIDsAndCovers			( 2), new PacketSyncDataLongAndIDsAndCovers			( 3), new PacketSyncDataLongAndIDsAndCovers			( 4), new PacketSyncDataLongAndIDsAndCovers			( 5), new PacketSyncDataLongAndIDsAndCovers			( 6), new PacketSyncDataLongAndIDsAndCovers			( 7)
		, new PacketSyncDataByteArrayAndIDsAndCovers	( 0), new PacketSyncDataByteArrayAndIDsAndCovers	( 1), new PacketSyncDataByteArrayAndIDsAndCovers	( 2), new PacketSyncDataByteArrayAndIDsAndCovers	( 3), new PacketSyncDataByteArrayAndIDsAndCovers	( 4), new PacketSyncDataByteArrayAndIDsAndCovers	( 5), new PacketSyncDataByteArrayAndIDsAndCovers	( 6), new PacketSyncDataByteArrayAndIDsAndCovers	( 7)
		, new PacketSyncDataCoverVisuals				( 0), new PacketSyncDataCoverVisuals				( 1), new PacketSyncDataCoverVisuals				( 2), new PacketSyncDataCoverVisuals				( 3), new PacketSyncDataCoverVisuals				( 4), new PacketSyncDataCoverVisuals				( 5), new PacketSyncDataCoverVisuals				( 6), new PacketSyncDataCoverVisuals				( 7)
		, new PacketSyncDataByteAndCoverVisuals			( 0), new PacketSyncDataByteAndCoverVisuals			( 1), new PacketSyncDataByteAndCoverVisuals			( 2), new PacketSyncDataByteAndCoverVisuals			( 3), new PacketSyncDataByteAndCoverVisuals			( 4), new PacketSyncDataByteAndCoverVisuals			( 5), new PacketSyncDataByteAndCoverVisuals			( 6), new PacketSyncDataByteAndCoverVisuals			( 7)
		, new PacketSyncDataShortAndCoverVisuals		( 0), new PacketSyncDataShortAndCoverVisuals		( 1), new PacketSyncDataShortAndCoverVisuals		( 2), new PacketSyncDataShortAndCoverVisuals		( 3), new PacketSyncDataShortAndCoverVisuals		( 4), new PacketSyncDataShortAndCoverVisuals		( 5), new PacketSyncDataShortAndCoverVisuals		( 6), new PacketSyncDataShortAndCoverVisuals		( 7)
		, new PacketSyncDataIntegerAndCoverVisuals		( 0), new PacketSyncDataIntegerAndCoverVisuals		( 1), new PacketSyncDataIntegerAndCoverVisuals		( 2), new PacketSyncDataIntegerAndCoverVisuals		( 3), new PacketSyncDataIntegerAndCoverVisuals		( 4), new PacketSyncDataIntegerAndCoverVisuals		( 5), new PacketSyncDataIntegerAndCoverVisuals		( 6), new PacketSyncDataIntegerAndCoverVisuals		( 7)
		, new PacketSyncDataLongAndCoverVisuals			( 0), new PacketSyncDataLongAndCoverVisuals			( 1), new PacketSyncDataLongAndCoverVisuals			( 2), new PacketSyncDataLongAndCoverVisuals			( 3), new PacketSyncDataLongAndCoverVisuals			( 4), new PacketSyncDataLongAndCoverVisuals			( 5), new PacketSyncDataLongAndCoverVisuals			( 6), new PacketSyncDataLongAndCoverVisuals			( 7)
		, new PacketSyncDataByteArrayAndCoverVisuals	( 0), new PacketSyncDataByteArrayAndCoverVisuals	( 1), new PacketSyncDataByteArrayAndCoverVisuals	( 2), new PacketSyncDataByteArrayAndCoverVisuals	( 3), new PacketSyncDataByteArrayAndCoverVisuals	( 4), new PacketSyncDataByteArrayAndCoverVisuals	( 5), new PacketSyncDataByteArrayAndCoverVisuals	( 6), new PacketSyncDataByteArrayAndCoverVisuals	( 7)
		, new PacketSound								( 0), new PacketSound								( 1), new PacketSound								( 2), new PacketSound								( 3), new PacketSound								( 4), new PacketSound								( 5), new PacketSound								( 6), new PacketSound								( 7)
		);
		// Registering the TileEntity used for Meta-Generated Blocks to store the 32000 variations.
		GameRegistry.registerTileEntity(PrefixBlockTileEntity.class, "gt.MetaBlockTileEntity");
		// Creating and loading the Lang File.
    	LanguageHandler.sLangFile = new Configuration(new File(aEvent.getModConfigurationDirectory().getParentFile(), "GregTech.lang"));
    	// Creating and loading the Unification Config.
    	OreDictManager.INSTANCE.mUnificationConfig = new Config(new Configuration(new File(new File(aEvent.getModConfigurationDirectory(), "GregTech"), "Unification.cfg")));
    	// Initialising the Re-Registrations.
    	new LoaderOreDictReRegistrations().run();
    	// Register the Falling MetaBlock Entity.
        EntityRegistry.registerModEntity(PrefixBlockFallingEntity.class, "gt.MetaBlockFallingEntity", 0, instance, 160, 1, true);
        // Initialise Enchantments.
		new Enchantment_EnderDamage();
		new Enchantment_Radioactivity();
		// Initialises the Fluid Display Item.
		IL.Display_Fluid.set(new ItemFluidDisplay());
		// Initialises the Integrated Circuit Item.
		IL.Circuit_Integrated.set(new ItemIntegratedCircuit("gt.integrated_circuit", "Integrated Circuit"));
        // Initialise Render Stuff and similar.
        api_proxy.onPreLoad();
        // Register the GUI Handler.
    	NetworkRegistry.INSTANCE.registerGuiHandler(instance, api_proxy);
        // schedule ItemList and Data loading.
		(sGregTechLoaded?sGTPreInitBefore:sAPIInitBefore).add(0, new LoaderItemList());
		(sGregTechLoaded?sGTPreInitBefore:sAPIInitBefore).add(1, new LoaderItemData());
        // GregTech is not loaded? Then these Load Phase Runnable Classes are useless.
		if (!sGregTechLoaded) {
			sGTPreInitBefore		.clear();	sGTPreInitBefore		= null;	sGTPreInitAfter			.clear();	sGTPreInitAfter			= null;
			sGTInitBefore			.clear();	sGTInitBefore			= null;	sGTInitAfter			.clear();	sGTInitAfter			= null;
			sGTPostInitBefore		.clear();	sGTPostInitBefore		= null;	sGTPostInitAfter		.clear();	sGTPostInitAfter		= null;
			sGTServerStartingBefore	.clear();	sGTServerStartingBefore	= null;	sGTServerStartingAfter	.clear();	sGTServerStartingAfter	= null;
			sGTServerStartedBefore	.clear();	sGTServerStartedBefore	= null;	sGTServerStartedAfter	.clear();	sGTServerStartedAfter	= null;
			sGTServerStoppingBefore	.clear();	sGTServerStoppingBefore	= null;	sGTServerStoppingAfter	.clear();	sGTServerStoppingAfter	= null;
			sGTServerStoppedBefore	.clear();	sGTServerStoppedBefore	= null;	sGTServerStoppedAfter	.clear();	sGTServerStoppedAfter	= null;
		}
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onPreLoad(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
		
		sAPIPhaseFinishedPreLoad = true;
		
        GT_Log.out.println("GT_API: PreLoad-Phase finished!");
        GT_Log.ore.println("GT_API: PreLoad-Phase finished!");
        
    	for (Runnable tRunnable : sAPIPreInitAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
    	sAPIPreInitAfter.clear();
    	sAPIPreInitAfter = null;
    	
        GT_Log.out.println("GT_API: =======================");
        GT_Log.ore.println("GT_API: =======================");
    }
    
	@EventHandler
    public void onLoad(FMLInitializationEvent aEvent) {
        GT_Log.out.println("GT_API: ===================");
        GT_Log.ore.println("GT_API: ===================");
        
    	for (Runnable tRunnable : sAPIInitBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
    	sAPIInitBefore.clear();
    	sAPIInitBefore = null;
    	
        GT_Log.out.println("GT_API: Load-Phase started!");
        GT_Log.ore.println("GT_API: Load-Phase started!");
        
		sAPIPhaseStartedLoad = true;
		
		// Because most of those Mods (and vanilla MC) are not OreDict Compatible and need to be set as Target manually.
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.FierySteel			, GT_ModHandler.getModItem(ModIDs.TF, "item.fieryIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Knightmetal		, GT_ModHandler.getModItem(ModIDs.TF, "item.knightMetal", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Steeleaf			, GT_ModHandler.getModItem(ModIDs.TF, "item.steeleafIngot", 1, 0));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.IronWood			, GT_ModHandler.getModItem(ModIDs.TF, "item.ironwoodIngot", 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedAir			, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedFire		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 1));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedWater		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 2));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEarth		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 3));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedOrder		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 4));
        OreDictManager.INSTANCE.setTarget(OP.gem			, MT.InfusedEntropy		, GT_ModHandler.getModItem(ModIDs.TC, "ItemShard", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Hg					, GT_ModHandler.getModItem(ModIDs.TC, "ItemNugget", 1, 5));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Thaumium			, GT_ModHandler.getModItem(ModIDs.TC, "ItemNugget", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.VoidMetal			, GT_ModHandler.getModItem(ModIDs.TC, "ItemNugget", 1, 7));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Thaumium			, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1, 2));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.VoidMetal			, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1,16));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Hg					, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1, 3));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Amber				, GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1, 6));
		OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Thaumium			, GT_ModHandler.getModItem(ModIDs.TC, "blockCosmeticSolid", 1, 4));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Firestone			, GT_ModHandler.getModItem(ModIDs.RC, "firestone.raw", 1));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Fe					, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Steel				, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 1));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.TinAlloy			, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 2));
    	OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Cu					, GT_ModHandler.getModItem(ModIDs.RC, "part.plate", 1, 3));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Cocoa				, GT_ModHandler.getModItem(ModIDs.HaC, "cocoapowderItem", 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Coffee				, IL.IC2_CoffeePowder.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Empty				, IL.Cell_Empty.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Lava				, IL.Cell_Lava.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Water				, IL.Cell_Water.get(1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.Creosote			, GT_ModHandler.getModItem(ModIDs.RC, "fluid.creosote.cell", 1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.UUMatter			, GT_ModHandler.getIC2Item("uuMatterCell", 1));
    	OreDictManager.INSTANCE.setTarget(OP.cell			, MT.ConstructionFoam	, GT_ModHandler.getIC2Item("CFCell", 1));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Empty				, new ItemStack(Items.bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Water				, new ItemStack(Items.water_bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Lava				, new ItemStack(Items.lava_bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bucket			, MT.Milk				, new ItemStack(Items.milk_bucket, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Empty				, new ItemStack(Items.glass_bottle, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.bottle			, MT.Water				, new ItemStack(Items.potionitem, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.plateAlloy		, MT.Iridium			, GT_ModHandler.getIC2Item("iridiumPlate", 1));
    	OreDictManager.INSTANCE.setTarget(OP.plateAlloy		, MT.Advanced			, GT_ModHandler.getIC2Item("advancedAlloy", 1));
    	OreDictManager.INSTANCE.setTarget(OP.plateAlloy		, MT.Carbon				, GT_ModHandler.getIC2Item("carbonPlate", 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Coal				, new ItemStack(Blocks.coal_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Iron				, new ItemStack(Blocks.iron_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Lapis				, new ItemStack(Blocks.lapis_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone			, new ItemStack(Blocks.redstone_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Redstone			, new ItemStack(Blocks.lit_redstone_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Gold				, new ItemStack(Blocks.gold_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Diamond			, new ItemStack(Blocks.diamond_ore, 1));
    	OreDictManager.INSTANCE.setTarget(OP.ore			, MT.Emerald			, new ItemStack(Blocks.emerald_ore, 1));
        OreDictManager.INSTANCE.setTarget(OP.ore			, MT.NetherQuartz		, new ItemStack(Blocks.quartz_ore, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Iridium			, GT_ModHandler.getIC2Item("iridiumOre", 1));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Lapis				, new ItemStack(Items.dye, 1, 4));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderEye			, new ItemStack(Items.ender_eye, 1));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.EnderPearl			, new ItemStack(Items.ender_pearl, 1));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Diamond			, new ItemStack(Items.diamond, 1));
		OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Emerald			, new ItemStack(Items.emerald, 1));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Coal				, new ItemStack(Items.coal, 1, 0));
	    OreDictManager.INSTANCE.setTarget(OP.gem			, MT.Charcoal			, new ItemStack(Items.coal, 1, 1));
    	OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherQuartz		, new ItemStack(Items.quartz, 1));
    	OreDictManager.INSTANCE.setTarget(OP.gem			, MT.NetherStar			, new ItemStack(Items.nether_star, 1));
		OreDictManager.INSTANCE.setTarget(OP.nugget			, MT.Gold				, new ItemStack(Items.gold_nugget, 1));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Gold				, new ItemStack(Items.gold_ingot, 1));
		OreDictManager.INSTANCE.setTarget(OP.ingot			, MT.Iron				, new ItemStack(Items.iron_ingot, 1));
		OreDictManager.INSTANCE.setTarget(OP.plate			, MT.Paper				, new ItemStack(Items.paper, 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Sugar				, new ItemStack(Items.sugar, 1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Bone				, IL.Dye_Bonemeal.get(1));
		OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Redstone			, new ItemStack(Items.redstone, 1));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Gunpowder			, new ItemStack(Items.gunpowder, 1));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Glowstone			, new ItemStack(Items.glowstone_dust, 1));
    	OreDictManager.INSTANCE.setTarget(OP.dust			, MT.Blaze				, new ItemStack(Items.blaze_powder, 1));
    	OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Blaze				, new ItemStack(Items.blaze_rod, 1));
		OreDictManager.INSTANCE.setTarget(OP.stick			, MT.Wood				, new ItemStack(Items.stick, 1));
        OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Iron				, new ItemStack(Blocks.iron_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockIngot		, MT.Gold				, new ItemStack(Blocks.gold_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Diamond			, new ItemStack(Blocks.diamond_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Emerald			, new ItemStack(Blocks.emerald_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Lapis				, new ItemStack(Blocks.lapis_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockGem		, MT.Coal				, new ItemStack(Blocks.coal_block, 1, 0));
        OreDictManager.INSTANCE.setTarget(OP.blockDust		, MT.Redstone			, new ItemStack(Blocks.redstone_block, 1, 0));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Fe					, GT_ModHandler.getIC2Item("casingiron", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Au					, GT_ModHandler.getIC2Item("casinggold", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Cu					, GT_ModHandler.getIC2Item("casingcopper", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Sn					, GT_ModHandler.getIC2Item("casingtin", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Pb					, GT_ModHandler.getIC2Item("casinglead", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Bronze				, GT_ModHandler.getIC2Item("casingbronze", 1));
    	OreDictManager.INSTANCE.setTarget(OP.casingSmall	, MT.Steel				, GT_ModHandler.getIC2Item("casingadviron", 1));
    	
		OM.blacklist(GT_ModHandler.getModItem(ModIDs.TC, "ItemResource", 1,18));
		
		GT_Log.out.println("GT_API: Doing a lot of the OreDictionary work (populating HashMaps for enabling faster access to Data and parsing Stuff). This will take a while. Like a LOT of time.");
		GT_Log.out.println("GT_API: If it seriously takes more than a hour then you definetly ran out of Memory or permgenspace, look at the other Logs to confirm it.");
		OreDictManager.INSTANCE.enableRegistrations();
		GT_Log.out.println("GT_API: Finished a lot of the OreDictionary work.");
        
        api_proxy.onLoad();
        
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onLoad(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
        
		sAPIPhaseFinishedLoad = true;
		
        GT_Log.out.println("GT_API: Load-Phase finished!");
        GT_Log.ore.println("GT_API: Load-Phase finished!");
        
    	for (Runnable tRunnable : sAPIInitAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
    	sAPIInitAfter.clear();
    	sAPIInitAfter = null;
    	
        GT_Log.out.println("GT_API: ====================");
        GT_Log.ore.println("GT_API: ====================");
	}
	
	@EventHandler
    public void onPostLoad(FMLPostInitializationEvent aEvent) {
        GT_Log.out.println("GT_API: =======================");
        GT_Log.ore.println("GT_API: =======================");
        
    	for (Runnable tRunnable : sAPIPostInitBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPostInitBefore.clear();
    	sAPIPostInitBefore = null;
    	
        GT_Log.out.println("GT_API: PostLoad-Phase started!");
        GT_Log.ore.println("GT_API: PostLoad-Phase started!");
        
		sAPIPhaseStartedPostLoad = true;
		
		GT_Log.out.println("GT_API: Doing a lot of more OreDictionary work (Registering Recipes). This will take a while. Like a LOT of time.");
		GT_Log.out.println("GT_API: If it seriously takes more than a hour then you definetly ran out of Memory or permgenspace, look at the other Logs to confirm it.");
		OreDictManager.INSTANCE.onPostLoad();
		GT_Log.out.println("GT_API: Finished another batch of the OreDictionary work.");
        
		
		// Saving the Lang File.
		LanguageHandler.save();
        api_proxy.onPostLoad();
		Recipe.reInit();
        
        if (mPlayerLogger != null) new Thread(mPlayerLogger).start();
        
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onPostLoad(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
		
		sAPIPhaseFinishedPostLoad = true;
		
		sEnableDynamicWritingToConfig = !sGregTechLoaded;
		
        GT_Log.out.println("GT_API: PostLoad-Phase finished!");
        GT_Log.ore.println("GT_API: PostLoad-Phase finished!");
        
    	for (Runnable tRunnable : sAPIPostInitAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	sAPIPostInitAfter.clear();
    	sAPIPostInitAfter = null;
    	
        GT_Log.out.println("GT_API: ========================");
        GT_Log.ore.println("GT_API: ========================");
    }
    
//  @SubscribeEvent
//  @EventHandler
//  public void loadComplete(FMLLoadCompleteEvent aEvent) {
//		Why the fuck doesn't this work!?! Who can actually receive this Event? Both annotations won't work...
//  }
	
	@EventHandler
    public void onServerStarting(FMLServerStartingEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStartingBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		sAPIPhaseStartedServerStarting = true;
		
		
		
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStarting(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
		
    	sAPIPhaseFinishedServerStarting = true;
    	
    	for (Runnable tRunnable : sAPIServerStartingAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
    
	@EventHandler
    public void onServerStarted(FMLServerStartedEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStartedBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		FluidStackContainer.fixAllThoseFuckingFluidIDs();
    	for (Map tMap : FLUIDMAPS) UT.Code.reMap(tMap);
		for (Map tMap : STACKMAPS) UT.Code.reMap(tMap);
    	UT.Fluids.reInit();
    	Recipe.reInit();
		
		sAPIPhaseStartedServerStarted = true;
		
    	GT_Log.out.println("GT_API: Unificating outputs of all known Recipe Types.");
    	HashSetNoNulls<ItemStack> tStacks = new HashSetNoNulls<ItemStack>(10000);
    	
    	try {
    	GT_Log.out.println("GT_API: IC2 Machines");
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.cannerBottle				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.centrifuge				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.compressor				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.extractor					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.macerator					.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerCutting		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerExtruding		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.metalformerRolling		.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.matterAmplifier			.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	for (ic2.api.recipe.RecipeOutput tRecipe : ic2.api.recipe.Recipes.oreWashing				.getRecipes().values()) for (ItemStack tStack : tRecipe.items) tStacks.add(tStack);
    	} catch(Throwable e) {/**/}
    	
    	GT_Log.out.println("GT_API: Dungeon Loot");
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.DUNGEON_CHEST			).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.BONUS_CHEST				).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.VILLAGE_BLACKSMITH		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CROSSING		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_LIBRARY		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.STRONGHOLD_CORRIDOR		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_DISPENSER	).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_JUNGLE_CHEST		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.PYRAMID_DESERT_CHEST		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	for (WeightedRandomChestContent tContent : ChestGenHooks.getInfo(ChestGenHooks.MINESHAFT_CORRIDOR		).getItems(RANDOM)) tStacks.add(tContent.theItemId);
    	GT_Log.out.println("GT_API: Smelting");
    	for (Object tStack : FurnaceRecipes.smelting().getSmeltingList().values()) tStacks.add((ItemStack)tStack);
    	GT_Log.out.println("GT_API: Crafting Recipes");
        for (Object tRecipe : CraftingManager.getInstance().getRecipeList()) if (tRecipe instanceof IRecipe) tStacks.add(((IRecipe)tRecipe).getRecipeOutput());
	    
	    for (ItemStack tOutput : tStacks) {
	    	if (OreDictManager.INSTANCE.isOreDictItem(tOutput)) {
	    		FMLLog.severe("GT-ERR-01: @ " + tOutput.getUnlocalizedName() + "   " + tOutput.getDisplayName());
	    		FMLLog.severe("A Recipe used an OreDict Item as Output directly, without copying it before!!! This is a typical CallByReference/CallByValue Error");
	    		FMLLog.severe("Said Item will be renamed to make the invalid Recipe visible, so that you can report it properly.");
	    		FMLLog.severe("Please check all Recipes outputting this Item, and report the Recipes to their Owner.");
	    		FMLLog.severe("The Owner of the ==>RECIPE<==, NOT the Owner of the Item, which has been mentioned above!!!");
	    		FMLLog.severe("And ONLY Recipes which are ==>OUTPUTTING<== the Item, sorry but I don't want failed Bug Reports.");
	    		FMLLog.severe("GregTech just reports this Error to you, so you can report it to the Mod causing the Problem.");
	    		FMLLog.severe("Even though I make that Bug visible, I can not and will not fix that for you, that's for the causing Mod to fix.");
	    		FMLLog.severe("And speaking of failed Reports:");
	    		FMLLog.severe("Both IC2 and GregTech CANNOT be the CAUSE of this Problem, so don't report it to either of them.");
	    		FMLLog.severe("I REPEAT, BOTH, IC2 and GregTech CANNOT be the source of THIS BUG. NO MATTER WHAT.");
	    		FMLLog.severe("Asking in the IC2 Forums, which Mod is causing that, won't help anyone, since it is not possible to determine, which Mod it is.");
	    		FMLLog.severe("If it would be possible, then I would have had added the Mod which is causing it to the Message already. But it is not possible.");
	    		FMLLog.severe("Sorry, but this Error is serious enough to justify this Wall-O-Text and the partially allcapsed Language.");
	    		FMLLog.severe("Also it is a Ban Reason on the IC2-Forums to seriously post this Text. We all know about its existence.");
	    		tOutput.setStackDisplayName("ERROR! CHECK THE FML LOG FOR 'GT-ERR-01' FOR MORE DETAILS!");
	    	} else {
		    	OM.set(tOutput);
	    	}
	    }
	    
        GT_Log.out.println("GT_API: Cleaning up all OreDict Crafting Recipes, which have an empty List in them, since they are never meeting any Condition.");
        List tList = CraftingManager.getInstance().getRecipeList();
        for (int i = 0; i < tList.size(); i++) {
        	Object tRecipe = tList.get(i);
        	if (tRecipe instanceof ShapedOreRecipe) {
        		Object[] tInput = ((ShapedOreRecipe)tRecipe).getInput();
        		for (int j = 0; j < tInput.length; j++) {
        			if (tInput[j] instanceof List && ((List)tInput[j]).isEmpty()) {
//        				GT_Log.deb.println("Removed Recipe for " + ((ShapedOreRecipe)tRecipe).getRecipeOutput().getDisplayName() + " because Ingredient Nr. " + j + " is missing");
        				tList.remove(i--);
        				break;
        			}
        		}
        	} else if (tRecipe instanceof ShapelessOreRecipe) {
        		ArrayList<Object> tInput = ((ShapelessOreRecipe)tRecipe).getInput();
        		for (int j = 0; j < tInput.size(); j++) {
        			if (tInput.get(j) instanceof List && ((List)tInput.get(j)).isEmpty()) {
//        				GT_Log.deb.println("Removed Recipe for " + ((ShapelessOreRecipe)tRecipe).getRecipeOutput().getDisplayName() + " because Ingredient Nr. " + j + " is missing");
        				tList.remove(i--);
        				break;
        			}
        		}
        	}
        }
        
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStarted(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
		
		sAPIPhaseFinishedServerStarted = true;
		
    	for (Runnable tRunnable : sAPIServerStartedAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
	
	@EventHandler
	public void onIDChangingEvent(FMLModIdMappingEvent aEvent) {
    	UT.Fluids.reInit();
    	Recipe.reInit();
    	
		FluidStackContainer.fixAllThoseFuckingFluidIDs();
    	for (Map tMap : FLUIDMAPS) UT.Code.reMap(tMap);
		for (Map tMap : STACKMAPS) UT.Code.reMap(tMap);
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onIDChanging(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
	}
	
	@EventHandler
    public void onServerStopping(FMLServerStoppingEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStoppingBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		sAPIPhaseStartedServerStopping = true;
		
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStopping(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
		
		sAPIPhaseFinishedServerStopping = true;
		
    	for (Runnable tRunnable : sAPIServerStoppingAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
	
	@EventHandler
    public void onServerStopped(FMLServerStoppedEvent aEvent) {
    	for (Runnable tRunnable : sAPIServerStoppedBefore) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    	
		sAPIPhaseStartedServerStopped = true;
		
		
		for (CompatBase tCompat : CompatBase.COMPAT_CLASSES) try {tCompat.onServerStopped(aEvent);} catch(Throwable e) {if (D1) e.printStackTrace(GT_Log.err);}
		
		sAPIPhaseFinishedServerStopped = true;
		
    	for (Runnable tRunnable : sAPIServerStoppedAfter) {
    		try {
    			tRunnable.run();
    		} catch(Throwable e) {
    			e.printStackTrace(GT_Log.err);
    		}
    	}
    }
}