package gregapi.tileentity;

import static gregapi.data.CS.NBT_COVERS;
import static gregapi.data.CS.TOOL_crowbar;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnToolClick;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataCovers;
import gregapi.code.ArrayListNoNulls;
import gregapi.network.INetworkHandler;
import gregapi.network.IPacket;
import gregapi.network.packets.covers.*;
import gregapi.network.packets.covervisuals.*;
import gregapi.network.packets.data.*;
import gregapi.network.packets.ids.*;
import gregapi.render.ITexture;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;

/**
 * @author Gregorius Techneticies
 */
public abstract class TileEntityBase6 extends TileEntityBase5 implements IMTE_SyncDataCovers, IMTE_OnToolClick, ITileEntitySurface {
	protected short[] mCoverIDs, mCoverMetas, mCoverVisuals;
	protected boolean[] mCoverVisualsToSync;
	protected NBTTagCompound[] mCoverNBTs;
	
    @Override
	public void readFromNBT2(NBTTagCompound aNBT) {
    	super.readFromNBT2(aNBT);
    	if (aNBT.hasKey(NBT_COVERS)) {
    		NBTTagCompound tNBT = aNBT.getCompoundTag(NBT_COVERS);
    		mCoverIDs		= new short[] {tNBT.getShort("a"), tNBT.getShort("b"), tNBT.getShort("c"), tNBT.getShort("d"), tNBT.getShort("e"), tNBT.getShort("f")};
    		mCoverMetas		= new short[] {tNBT.getShort("g"), tNBT.getShort("h"), tNBT.getShort("i"), tNBT.getShort("j"), tNBT.getShort("k"), tNBT.getShort("l")};
    		mCoverVisuals	= new short[] {tNBT.getShort("m"), tNBT.getShort("n"), tNBT.getShort("o"), tNBT.getShort("p"), tNBT.getShort("q"), tNBT.getShort("r")};
    		mCoverNBTs		= new NBTTagCompound[] {tNBT.getCompoundTag("s"), tNBT.getCompoundTag("t"), tNBT.getCompoundTag("u"), tNBT.getCompoundTag("v"), tNBT.getCompoundTag("w"), tNBT.getCompoundTag("x")};
        }
    }
    
    @Override
	public void writeToNBT2(NBTTagCompound aNBT) {
    	super.writeToNBT2(aNBT);
    	if (mCoverIDs != null) {
    		NBTTagCompound tNBT = new NBTTagCompound();
    		tNBT.setShort("a", mCoverIDs		[0]); tNBT.setShort("b", mCoverIDs		[1]); tNBT.setShort("c", mCoverIDs		[2]); tNBT.setShort("d", mCoverIDs		[3]); tNBT.setShort("e", mCoverIDs		[4]); tNBT.setShort("f", mCoverIDs		[5]); 
    		tNBT.setShort("g", mCoverMetas		[0]); tNBT.setShort("h", mCoverMetas	[1]); tNBT.setShort("i", mCoverMetas	[2]); tNBT.setShort("j", mCoverMetas	[3]); tNBT.setShort("k", mCoverMetas	[4]); tNBT.setShort("l", mCoverMetas	[5]);
    		tNBT.setShort("m", mCoverVisuals	[0]); tNBT.setShort("n", mCoverVisuals	[1]); tNBT.setShort("o", mCoverVisuals	[2]); tNBT.setShort("p", mCoverVisuals	[3]); tNBT.setShort("q", mCoverVisuals	[4]); tNBT.setShort("r", mCoverVisuals	[5]);
    		tNBT.setTag  ("s", mCoverNBTs		[0]); tNBT.setTag  ("t", mCoverNBTs		[1]); tNBT.setTag  ("u", mCoverNBTs		[2]); tNBT.setTag  ("v", mCoverNBTs		[3]); tNBT.setTag  ("w", mCoverNBTs		[4]); tNBT.setTag  ("x", mCoverNBTs		[5]);
    		aNBT.setTag(NBT_COVERS, tNBT);
    	}
    }
    
    @Override
	public boolean receiveDataCovers(short[] aCoverVisuals, INetworkHandler aNetworkHandler) {
		mCoverVisuals = aCoverVisuals;
		return true;
	}
    
    @Override
	public boolean receiveDataCovers(short[] aCoverIDs, short[] aCoverMetas, INetworkHandler aNetworkHandler) {
		mCoverIDs = aCoverIDs;
		mCoverMetas = aCoverMetas;
		return true;
	}
    
    @Override
    public ArrayListNoNulls<ItemStack> getDrops(int aFortune, boolean aSilkTouch) {
    	ArrayListNoNulls<ItemStack> rList = super.getDrops(aFortune, aSilkTouch);
    	if (mCoverIDs != null && rList.size() == 1) {
    		NBTTagCompound tNBT = new NBTTagCompound(), aNBT = rList.get(0).getTagCompound();
    		tNBT.setShort("a", mCoverIDs		[0]); tNBT.setShort("b", mCoverIDs		[1]); tNBT.setShort("c", mCoverIDs		[2]); tNBT.setShort("d", mCoverIDs		[3]); tNBT.setShort("e", mCoverIDs		[4]); tNBT.setShort("f", mCoverIDs		[5]); 
    		tNBT.setShort("g", mCoverMetas		[0]); tNBT.setShort("h", mCoverMetas	[1]); tNBT.setShort("i", mCoverMetas	[2]); tNBT.setShort("j", mCoverMetas	[3]); tNBT.setShort("k", mCoverMetas	[4]); tNBT.setShort("l", mCoverMetas	[5]);
    		tNBT.setTag  ("s", mCoverNBTs		[0]); tNBT.setTag  ("t", mCoverNBTs		[1]); tNBT.setTag  ("u", mCoverNBTs		[2]); tNBT.setTag  ("v", mCoverNBTs		[3]); tNBT.setTag  ("w", mCoverNBTs		[4]); tNBT.setTag  ("x", mCoverNBTs		[5]);
    		if (aNBT == null) aNBT = new NBTTagCompound();
    		aNBT.setTag(NBT_COVERS, tNBT);
    		rList.get(0).setTagCompound(aNBT);
    	}
    	return rList;
    }
    
	@Override
	public long onToolClick(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSide, float aHitX, float aHitY, float aHitZ) {
		if (checkObstruction(aPlayer instanceof EntityPlayer ? (EntityPlayer)aPlayer : null, aSide, aHitX, aHitY, aHitZ)) return 0;
		if (aTool.equals(TOOL_crowbar) && !worldObj.isRemote && mCoverIDs != null && mCoverIDs[aSide] != 0) {
			ItemStack tStack = getCoverItem(aSide);
			setCoverItem(aSide, null, aPlayer, false, true);
			worldObj.spawnEntityInWorld(new EntityItem(worldObj, getOffsetX(aSide, 1)+0.5, getOffsetY(aSide, 1)+0.5, getOffsetZ(aSide, 1)+0.5, tStack));
			UT.Sounds.send(worldObj, "random.break", 1.0F, -1.0F, xCoord, yCoord, zCoord);
			return 10000;
		}
		return onToolClick2(aTool, aRemainingDurability, aQuality, aPlayer, aPlayerInventory, aSneaking, aStack, aSide, aHitX, aHitY, aHitZ);
	}
	
	public long onToolClick2(String aTool, long aRemainingDurability, long aQuality, Entity aPlayer, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSide, float aHitX, float aHitY, float aHitZ) {
		return 0;
	}
	
	@Override public IPacket getClientDataPacket(boolean aSendAll)								{return aSendAll ? mCoverIDs == null ? new PacketSyncDataIDs				(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID()				) : new PacketSyncDataIDsAndCovers				(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID()				, mCoverIDs, mCoverMetas, mCoverVisuals) : UT.Code.containsBoolean(true, mCoverVisualsToSync) ? new PacketSyncDataCoverVisuals				(xCoord, yCoord, zCoord				, mCoverVisualsToSync, mCoverVisuals) : null;}
	@Override public IPacket getClientDataPacketByte(boolean aSendAll, byte aByte)				{return aSendAll ? mCoverIDs == null ? new PacketSyncDataByteAndIDs			(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aByte		) : new PacketSyncDataByteAndIDsAndCovers		(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aByte		, mCoverIDs, mCoverMetas, mCoverVisuals) : UT.Code.containsBoolean(true, mCoverVisualsToSync) ? new PacketSyncDataByteAndCoverVisuals		(xCoord, yCoord, zCoord, aByte		, mCoverVisualsToSync, mCoverVisuals) : new PacketSyncDataByte		(xCoord, yCoord, zCoord, aByte		);}
	@Override public IPacket getClientDataPacketShort(boolean aSendAll, short aShort)			{return aSendAll ? mCoverIDs == null ? new PacketSyncDataShortAndIDs		(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aShort		) : new PacketSyncDataShortAndIDsAndCovers		(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aShort		, mCoverIDs, mCoverMetas, mCoverVisuals) : UT.Code.containsBoolean(true, mCoverVisualsToSync) ? new PacketSyncDataShortAndCoverVisuals		(xCoord, yCoord, zCoord, aShort		, mCoverVisualsToSync, mCoverVisuals) : new PacketSyncDataShort		(xCoord, yCoord, zCoord, aShort		);}
	@Override public IPacket getClientDataPacketInteger(boolean aSendAll, int aInteger)			{return aSendAll ? mCoverIDs == null ? new PacketSyncDataIntegerAndIDs		(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aInteger	) : new PacketSyncDataIntegerAndIDsAndCovers	(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aInteger	, mCoverIDs, mCoverMetas, mCoverVisuals) : UT.Code.containsBoolean(true, mCoverVisualsToSync) ? new PacketSyncDataIntegerAndCoverVisuals	(xCoord, yCoord, zCoord, aInteger	, mCoverVisualsToSync, mCoverVisuals) : new PacketSyncDataInteger	(xCoord, yCoord, zCoord, aInteger	);}
	@Override public IPacket getClientDataPacketLong(boolean aSendAll, long aLong)				{return aSendAll ? mCoverIDs == null ? new PacketSyncDataLongAndIDs			(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aLong		) : new PacketSyncDataLongAndIDsAndCovers		(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aLong		, mCoverIDs, mCoverMetas, mCoverVisuals) : UT.Code.containsBoolean(true, mCoverVisualsToSync) ? new PacketSyncDataLongAndCoverVisuals		(xCoord, yCoord, zCoord, aLong		, mCoverVisualsToSync, mCoverVisuals) : new PacketSyncDataLong		(xCoord, yCoord, zCoord, aLong		);}
	@Override public IPacket getClientDataPacketByteArray(boolean aSendAll, byte... aByteArray)	{return aSendAll ? mCoverIDs == null ? new PacketSyncDataByteArrayAndIDs	(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aByteArray	) : new PacketSyncDataByteArrayAndIDsAndCovers	(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), aByteArray	, mCoverIDs, mCoverMetas, mCoverVisuals) : UT.Code.containsBoolean(true, mCoverVisualsToSync) ? new PacketSyncDataByteArrayAndCoverVisuals	(xCoord, yCoord, zCoord, aByteArray	, mCoverVisualsToSync, mCoverVisuals) : new PacketSyncDataByteArray	(xCoord, yCoord, zCoord, aByteArray	);}
	
	public boolean hasCovers() {
		return mCoverIDs != null;
	}
	
	public ItemStack getCoverItem(byte aSide) {
		return mCoverIDs == null && mCoverIDs[aSide] == 0 ? null : UT.Stacks.create(mCoverIDs[aSide], 1, mCoverIDs[aSide], mCoverNBTs[aSide]);
	}
	
	public boolean setCoverItem(byte aSide, ItemStack aStack, Entity aPlayer, boolean aForce, boolean aBlockUpdate) {
		updateClientData();
		boolean rReturn = true;
		
		if (mCoverIDs == null) {mCoverIDs = new short[6]; mCoverMetas = new short[6]; mCoverVisuals = new short[6]; mCoverNBTs = new NBTTagCompound[6]; mCoverVisualsToSync = new boolean[] {false, false, false, false, false, false};}
		
		mCoverIDs[aSide] = aStack == null ? 0 : (short)Item.getIdFromItem(aStack.getItem());
		mCoverMetas[aSide] = aStack == null ? 0 : (short)Items.feather.getDamage(aStack);
		mCoverNBTs[aSide] = aStack == null ? null : aStack.getTagCompound();
		
		if (aBlockUpdate) causeBlockUpdate();
		
		for (byte i = 0; i < 6; i++) if (mCoverIDs[i] != 0) return rReturn;
		mCoverIDs = mCoverMetas = mCoverVisuals = null;
		mCoverVisualsToSync = null;
		mCoverNBTs = null;
		return rReturn;
	}
	
    /** Writes eventual Item Data to the NBT. */
    public NBTTagCompound writeItemNBT2(NBTTagCompound aNBT) {return aNBT;}
    
	@Override
    public final NBTTagCompound writeItemNBT(NBTTagCompound aNBT) {
		aNBT = super.writeItemNBT(writeItemNBT2(aNBT));
    	if (mCoverIDs != null) {
    		NBTTagCompound tNBT = new NBTTagCompound();
    		if (mCoverIDs[0] != 0) {
        		tNBT.setShort("a", mCoverIDs		[0]);
        		tNBT.setShort("g", mCoverMetas		[0]);
        		tNBT.setTag  ("s", mCoverNBTs		[0]);
    		}
    		if (mCoverIDs[1] != 0) {
	    		tNBT.setShort("b", mCoverIDs		[1]);
	    		tNBT.setShort("h", mCoverMetas		[1]);
	    		tNBT.setTag  ("t", mCoverNBTs		[1]);
    		}
    		if (mCoverIDs[2] != 0) {
	    		tNBT.setShort("c", mCoverIDs		[2]);
	    		tNBT.setShort("i", mCoverMetas		[2]);
	    		tNBT.setTag  ("u", mCoverNBTs		[2]);
    		}
    		if (mCoverIDs[3] != 0) {
	    		tNBT.setShort("d", mCoverIDs		[3]);
	    		tNBT.setShort("j", mCoverMetas		[3]);
	    		tNBT.setTag  ("v", mCoverNBTs		[3]);
    		}
    		if (mCoverIDs[4] != 0) {
	    		tNBT.setShort("e", mCoverIDs		[4]);
	    		tNBT.setShort("k", mCoverMetas		[4]);
	    		tNBT.setTag  ("w", mCoverNBTs		[4]);
    		}
    		if (mCoverIDs[5] != 0) {
	    		tNBT.setShort("f", mCoverIDs		[5]); 
	    		tNBT.setShort("l", mCoverMetas		[5]);
	    		tNBT.setTag  ("x", mCoverNBTs		[5]);
    		}
    		if (!tNBT.hasNoTags()) aNBT.setTag(NBT_COVERS, tNBT);
    	}
    	return aNBT;
    }
    
	// Default Behaviour for full Blocks.
	@Override public final boolean setBlockBounds(Block aBlock, int aRenderPass) {return setBlockBounds2(aBlock, aRenderPass);}
	@Override public final int getRenderPasses(Block aBlock) {return getRenderPasses2(aBlock);}
	@Override public final ITexture getTexture(Block aBlock, int aRenderPass, byte aSide) {return getTexture2(aBlock, aRenderPass, aSide);}
	@Override public boolean renderItem(Block aBlock, RenderBlocks aRenderer) {return false;}
	@Override public boolean renderBlock(Block aBlock, RenderBlocks aRenderer) {return false;}
	
	public boolean setBlockBounds2(Block aBlock, int aRenderPass) {return false;}
	public int getRenderPasses2(Block aBlock) {return 1;}
	public abstract ITexture getTexture2(Block aBlock, int aRenderPass, byte aSide);
    
	// GUI Stuff
	@Override public final Object getGUIClient(int aGUIID, EntityPlayer aPlayer) {return aGUIID <= -1 && aGUIID >= -6 ? null /* TODO: Cover GUI */: getGUIClient2(aGUIID, aPlayer);}
	@Override public final Object getGUIServer(int aGUIID, EntityPlayer aPlayer) {return aGUIID <= -1 && aGUIID >= -6 ? null /* TODO: Cover GUI */: getGUIServer2(aGUIID, aPlayer);}
	public Object getGUIClient2(int aGUIID, EntityPlayer aPlayer) {return null;}
	public Object getGUIServer2(int aGUIID, EntityPlayer aPlayer) {return null;}
}